<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- module.qdoc -->
  <title>Module QML Type | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="qml-qbslanguageitems-joblimit.html" />
  <link rel="next" href="qml-qbslanguageitems-moduleprovider.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="qml-qbslanguageitems-joblimit.html">JobLimit</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-moduleprovider.html">ModuleProvider</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#properties">Properties</a></li>
<li class="level1"><a href="#details">Detailed Description</a></li>
<li class="level2"><a href="#accessing-product-and-module-properties">Accessing Product and Module Properties</a></li>
<li class="level2"><a href="#special-property-values">Special Property Values</a></li>
<li class="level2"><a href="#dependency-parameters">Dependency Parameters</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Module QML Type</h1>
<span class="subtitle"></span>
<!-- $$$Module-brief -->
<p>Represents a collection of properties and items that can be loaded into a product. <a href="#details">More...</a></p>
<!-- @@@Module -->
<div class="table"><table class="alignedsummary">
<tr><td class="memItemLeft rightAlign topAlign"> Import Statement:</td><td class="memItemRight bottomAlign"> import QbsLanguageItems .</td></tr></table></div><ul>
<li><a href="qml-qbslanguageitems-module-members.html">List of all members, including inherited members</a></li>
</ul>
<a name="properties"></a>
<h2 id="properties">Properties</h2>
<ul>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#additionalProductTypes-prop">additionalProductTypes</a></b></b> : stringList</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#condition-prop">condition</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#present-prop">present</a></b></b> : bool</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#priority-prop">priority</a></b></b> : int</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#setupBuildEnvironment-prop">setupBuildEnvironment</a></b></b> : script</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#setupRunEnvironment-prop">setupRunEnvironment</a></b></b> : script</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#validate-prop">validate</a></b></b> : script</li>
<li class="fn"><b><b><a href="qml-qbslanguageitems-module.html#version-prop">version</a></b></b> : string</li>
</ul>
<!-- $$$Module-description -->
<a name="details"></a>
<h2 id="details">Detailed Description</h2>
<p>A Module item is a collection of properties and language items. It contributes to building a product if the product has a <a href="qml-qbslanguageitems-depends.html">dependency</a> on the module. Modules may contain the following items:</p>
<ul>
<li><a href="qml-qbslanguageitems-depends.html">Depends</a></li>
<li><a href="qml-qbslanguageitems-filetagger.html">FileTagger</a></li>
<li><a href="qml-qbslanguageitems-group.html">Group</a></li>
<li><a href="qml-qbslanguageitems-joblimit.html">JobLimit</a></li>
<li><a href="qml-qbslanguageitems-parameter.html">Parameter</a></li>
<li><a href="qml-qbslanguageitems-probe.html">Probe</a></li>
<li><a href="qml-qbslanguageitems-propertyoptions.html">PropertyOptions</a></li>
<li><a href="qml-qbslanguageitems-rule.html">Rule</a></li>
<li><a href="qml-qbslanguageitems-scanner.html">Scanner</a></li>
</ul>
<p>When a product expresses a dependency on a module, Qbs will create an instance of the module item in the scope of the product. The product can then read and write properties from and to the loaded module, respectively.</p>
<p>Modules in different products are isolated from each other, just as products cannot access each other's properties. However, products can use the <a href="qml-qbslanguageitems-export.html">Export</a> item to pass dependencies and properties of modules to other dependent products.</p>
<p>The following (somewhat artificial) module pre-processes text files by removing certain characters from them. The module's name is <code>txt_processor</code>.</p>
<pre class="qml">

  import qbs.FileInfo
  import qbs.TextFile

  <span class="type"><a href="qml-qbslanguageitems-module.html">Module</a></span> {
      property <span class="type">stringList</span> <span class="name">unwantedCharacters</span>: []

      <span class="type"><a href="qml-qbslanguageitems-filetagger.html">FileTagger</a></span> {
          <span class="name">patterns</span>: [<span class="string">&quot;*.raw&quot;</span>]
          <span class="name">fileTags</span>: [<span class="string">&quot;raw-txt&quot;</span>]
      }

      <span class="type"><a href="qml-qbslanguageitems-rule.html">Rule</a></span> {
          <span class="name">inputs</span>: [<span class="string">&quot;raw-txt&quot;</span>]

          <span class="type"><a href="qml-qbslanguageitems-artifact.html">Artifact</a></span> {
              <span class="name">filePath</span>: <span class="name">FileInfo</span>.<span class="name">relativePath</span>(<span class="name">input</span>.<span class="name">filePath</span>, <span class="name">product</span>.<span class="name">sourceDirectory</span>) <span class="operator">+</span>
                         <span class="string">&quot;/&quot;</span> <span class="operator">+</span> <span class="name">input</span>.<span class="name">fileName</span> <span class="operator">+</span> <span class="string">&quot;.processed&quot;</span>
              <span class="name">fileTags</span>: [<span class="string">&quot;processed-txt&quot;</span>]
          }

          <span class="name">prepare</span>: {
              var cmd = new <span class="name">JavaScriptCommand</span>();
              <span class="name">cmd</span>.<span class="name">description</span> <span class="operator">=</span> <span class="string">&quot;Processing &quot;</span> <span class="operator">+</span> <span class="name">input</span>.<span class="name">fileName</span>;
              <span class="name">cmd</span>.<span class="name">sourceCode</span> <span class="operator">=</span> <span class="keyword">function</span>() {
                  var inFile = new <span class="name">TextFile</span>(<span class="name">input</span>.<span class="name">filePath</span>, <span class="name">TextFile</span>.<span class="name">ReadOnly</span>);
                  var content = <span class="name">inFile</span>.<span class="name">readAll</span>();
                  <span class="name">inFile</span>.<span class="name">close</span>();
                  var unwantedChars = <span class="name">input</span>.<span class="name">txt_processor</span>.<span class="name">unwantedCharacters</span>;
                  <span class="keyword">for</span> (var c in <span class="name">unwantedChars</span>)
                      <span class="name">content</span> <span class="operator">=</span> <span class="name">content</span>.<span class="name">replace</span>(<span class="name">unwantedChars</span>[<span class="name">c</span>], <span class="string">&quot;&quot;</span>);
                  var outFile = new <span class="name">TextFile</span>(<span class="name">output</span>.<span class="name">filePath</span>, <span class="name">TextFile</span>.<span class="name">WriteOnly</span>);
                  <span class="name">outFile</span>.<span class="name">write</span>(<span class="name">content</span>);
                  <span class="name">outFile</span>.<span class="name">close</span>();
              };
              <span class="keyword">return</span> <span class="name">cmd</span>;
          }
      }
  }

</pre>
<p>And this is how a <a href="qml-qbslanguageitems-product.html">Product</a> would use the module:</p>
<pre class="qml">

  <span class="type"><a href="qml-qbslanguageitems-product.html">Product</a></span> {
      <span class="name">type</span>: <span class="string">&quot;processed-txt&quot;</span>
      <span class="type"><a href="qml-qbslanguageitems-depends.html">Depends</a></span> { <span class="name">name</span>: <span class="string">&quot;txt_processor&quot;</span> }
      <span class="name">txt_processor</span>.unwantedCharacters: [<span class="string">&quot;\r&quot;</span>]
      <span class="name">files</span>: [
          <span class="string">&quot;file1.raw&quot;</span>,
          <span class="string">&quot;file2.raw&quot;</span>
      ]
  }

</pre>
<p>The resulting files are tagged with <code>processed-txt</code> and might be consumed by a rule in another module. That is possible if another rule has <code>processed-txt</code> in its <a href="qml-qbslanguageitems-rule.html#inputs-prop">inputs</a> property.</p>
<p>For more information about how you make your own modules available to Qbs, see <a href="custom-modules.html">Custom Modules and Items</a>.</p>
<a name="accessing-product-and-module-properties"></a>
<h2 id="accessing-product-and-module-properties">Accessing Product and Module Properties</h2>
<p>When defining a property in a module item, the right-hand side expression is a binding. Bindings may reference other properties of:</p>
<ul>
<li>the current module</li>
<li>other modules that this module depends on</li>
<li>the dependent product</li>
</ul>
<p>Please note that this applies to bindings in modules only. Property access in rules and other nested items is different.</p>
<a name="accessing-properties-of-the-current-module"></a>
<h3 id="accessing-properties-of-the-current-module">Accessing Properties of the Current Module</h3>
<p>Sibling properties in the same module can be accessed directly by their name:</p>
<pre class="qml">

  <span class="type"><a href="qml-qbslanguageitems-module.html">Module</a></span> {
      property <span class="type">stringList</span> <span class="name">windowsDefaults</span>: [<span class="string">&quot;\r&quot;</span>]
      property <span class="type">stringList</span> <span class="name">unwantedCharacters</span>: <span class="name">windowsDefaults</span>
  }

</pre>
<a name="properties-of-the-dependent-modules"></a>
<h3 id="properties-of-the-dependent-modules">Properties of the Dependent Modules</h3>
<p>When a module loads another module through a <a href="qml-qbslanguageitems-depends.html">Depends</a> element, it can access properties of the other module through its name. Assuming there was a module <code>OtherModule</code> with a property <code>otherProperty</code>, such an access would look like this:</p>
<pre class="qml">

  <span class="type"><a href="qml-qbslanguageitems-module.html">Module</a></span> {
      <span class="type"><a href="qml-qbslanguageitems-depends.html">Depends</a></span> { <span class="name">name</span>: <span class="string">&quot;OtherModule&quot;</span> }
      property <span class="type">string</span> <span class="name">myProperty</span>: <span class="string">&quot;something-&quot;</span> <span class="operator">+</span> <span class="name">OtherModule</span>.<span class="name">otherProperty</span>
  }

</pre>
<a name="accessing-properties-of-the-dependent-product"></a>
<h3 id="accessing-properties-of-the-dependent-product">Accessing Properties of the Dependent Product</h3>
<pre class="qml">

  <span class="type"><a href="qml-qbslanguageitems-module.html">Module</a></span> {
      property <span class="type">bool</span> <span class="name">featureEnabled</span>:
              (<span class="name">product</span>.<span class="name">type</span>.<span class="name">contains</span>(<span class="string">&quot;application&quot;</span>)) ?  <span class="number">true</span> : <span class="number">false</span>
  }

</pre>
<a name="special-property-values"></a>
<h2 id="special-property-values">Special Property Values</h2>
<p>For every property defined in a module, Qbs provides the following special built-in values:</p>
<ul>
<li><a href="qml-qbslanguageitems-module.html#base">base</a></li>
<li><a href="qml-qbslanguageitems-module.html#original">original</a></li>
<li><a href="qml-qbslanguageitems-module.html#outer">outer</a></li>
</ul>
<a name="base"></a>
<h3 id="base"><code>base</code></h3>
<p>This value is useful when making use of inheritance. It stands for the value of the respective property in the item one level up in the inheritance chain. For instance:</p>
<pre class="cpp">

  Product { <span class="comment">// defined in MyProduct.qbs</span>
      Depends { name: <span class="string">&quot;mymodule&quot;</span> }
      mymodule<span class="operator">.</span>someProperty: <span class="operator">[</span><span class="string">&quot;value1&quot;</span><span class="operator">]</span>
  }
  <span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span> some other file <span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span>
  MyProduct {
      mymodule<span class="operator">.</span>someProperty: base<span class="operator">.</span>concat(<span class="operator">[</span><span class="string">&quot;value2&quot;</span><span class="operator">]</span>) <span class="comment">// =&gt; [&quot;value1&quot;, &quot;value2&quot;]</span>
  }

</pre>
<a name="original"></a>
<h3 id="original"><code>original</code></h3>
<p>This is the value of the property in the module itself (possibly overridden from a profile or the command line). Use it to set a module property conditionally:</p>
<pre class="cpp">

  Module { <span class="comment">// This is mymodule</span>
      property string aProperty: <span class="string">&quot;z&quot;</span>
  }
  <span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span>
  Product {
      Depends { name: <span class="string">&quot;mymodule&quot;</span> }
      Depends { name: <span class="string">&quot;myothermodule&quot;</span> }
      mymodule<span class="operator">.</span>aProperty: myothermodule<span class="operator">.</span>anotherProperty <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;x&quot;</span> <span class="operator">?</span> <span class="string">&quot;y&quot;</span> : original <span class="comment">// =&gt; &quot;y&quot; if myothermodule.anotherProperty is &quot;x&quot;, &quot;z&quot; otherwise</span>

</pre>
<a name="outer"></a>
<h3 id="outer"><code>outer</code></h3>
<p>This value is used in nested items, where it refers to the value of the respective property in the surrounding item. It is only valid in <a href="qml-qbslanguageitems-group.html">Group</a> and <a href="commands.html#properties">Properties</a> items:</p>
<pre class="cpp">

  Product {
      Depends { name: <span class="string">&quot;mymodule&quot;</span> }
      mymodule<span class="operator">.</span>someProperty: <span class="operator">[</span><span class="string">&quot;value1&quot;</span><span class="operator">]</span>
      Group {
          name: <span class="string">&quot;special files&quot;</span>
          files: <span class="operator">[</span><span class="string">&quot;somefile1&quot;</span><span class="operator">,</span> <span class="string">&quot;somefile2&quot;</span><span class="operator">]</span>
          mymodule<span class="operator">.</span>someProperty: outer<span class="operator">.</span>concat(<span class="operator">[</span><span class="string">&quot;value&quot;</span><span class="operator">]</span>) <span class="comment">// =&gt; [&quot;value1&quot;, &quot;value2&quot;]</span>
      }
  }

</pre>
<a name="dependency-parameters"></a>
<h2 id="dependency-parameters">Dependency Parameters</h2>
<p>Modules can declare dependency parameters. Those parameters can be set within <a href="qml-qbslanguageitems-depends.html">Depends</a> items. <a href="qml-qbslanguageitems-rule.html">Rules</a> of the module can read the parameters of dependencies and act accordingly.</p>
<p>In the following example, the module <i>foo</i> declares the parameter <code>ignore</code>. A dependency to <code>bar</code> then sets the parameter <code>foo.ignore</code> to <code>true</code>. A rule in <code>foo</code> ignores all dependencies that have <code>foo.ignore</code> set to true.</p>
<pre class="cpp">

  Module {    <span class="comment">// Definition of module 'foo'.</span>
      Parameter { property bool ignore }
      Rule {
          <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>
          prepare: {
              <span class="keyword">for</span> (i in product<span class="operator">.</span>dependencies) {
                  var dep <span class="operator">=</span> product<span class="operator">.</span>dependencies<span class="operator">[</span>i<span class="operator">]</span>;
                  <span class="keyword">if</span> (dep<span class="operator">.</span>foo<span class="operator">.</span>ignore)
                      <span class="keyword">continue</span>;
                  <span class="comment">// Do something with the dependency.</span>
              }
          }
      }
      <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>
  }
  <span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span><span class="operator">-</span>
  Product {
      Depends { name: <span class="string">&quot;foo&quot;</span> }
      Depends { name: <span class="string">&quot;bar&quot;</span>; foo<span class="operator">.</span>ignore: <span class="keyword">true</span> }
  }

</pre>
<!-- @@@Module -->
<h2>Property Documentation</h2>
<!-- $$$additionalProductTypes -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="additionalProductTypes-prop">
<td class="tblQmlPropNode"><p>
<span class="name">additionalProductTypes</span> : <span class="type">stringList</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A list of elements that will be added to the <a href="qml-qbslanguageitems-product.html#type-prop">type</a> property of a product that has a dependency on the module.</p>
<p>Default: <code>[]</code></p>
</div></div><!-- @@@additionalProductTypes -->
<br/>
<!-- $$$condition -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="condition-prop">
<td class="tblQmlPropNode"><p>
<span class="name">condition</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>Whether the module is enabled. If this property is <code>false</code>, the surrounding Module item will not be considered in the module look-up.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@condition -->
<br/>
<!-- $$$present -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="present-prop">
<td class="tblQmlPropNode"><p>
<span class="qmlreadonly">[read-only] </span><span class="name">present</span> : <span class="type">bool</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>This property is <code>false</code> if and only if the respective <a href="qml-qbslanguageitems-depends.html">Depends</a> item had its <a href="qml-qbslanguageitems-depends.html#required-prop">required</a> property set to <code>false</code> and the module was not found.</p>
<p>Default: <code>true</code></p>
</div></div><!-- @@@present -->
<br/>
<!-- $$$priority -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="priority-prop">
<td class="tblQmlPropNode"><p>
<span class="name">priority</span> : <span class="type">int</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The priority of this module instance. If there is more than one module instance available for a module name, the module with the highest priority is chosen.</p>
<p>Default: 0</p>
</div></div><!-- @@@priority -->
<br/>
<!-- $$$setupBuildEnvironment -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="setupBuildEnvironment-prop">
<td class="tblQmlPropNode"><p>
<span class="name">setupBuildEnvironment</span> : <span class="type">script</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A script for setting up the environment in which a product is built.</p>
<p>The code in this script is treated as a function with the signature <code>function(project, product)</code>.</p>
<p>Use the <a href="jsextension-environment.html">Environment</a> functions to alter the environment.</p>
<p>The return value of this script is ignored.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@setupBuildEnvironment -->
<br/>
<!-- $$$setupRunEnvironment -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="setupRunEnvironment-prop">
<td class="tblQmlPropNode"><p>
<span class="name">setupRunEnvironment</span> : <span class="type">script</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A script for setting up the environment in which a product is run.</p>
<p>The code in this script is treated as a function with the signature <code>function(project, product, config)</code>.</p>
<p>The <code>config</code> parameter is a list of arbitrary strings that can be passed via the <a href="cli-run.html">run</a> command. The values supported by specific modules are listed in their respective documentation.</p>
<p>Use the <a href="jsextension-environment.html">Environment</a> functions to alter the environment.</p>
<p>The return value of this script is ignored.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@setupRunEnvironment -->
<br/>
<!-- $$$validate -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="validate-prop">
<td class="tblQmlPropNode"><p>
<span class="name">validate</span> : <span class="type">script</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>A script that is run after the module is loaded. It can be used to check property values and throw errors in unexpected cases. The return value is ignored.</p>
<p>Default: Undefined</p>
</div></div><!-- @@@validate -->
<br/>
<!-- $$$version -->
<div class="qmlitem"><div class="qmlproto">
<div class="table"><table class="qmlname">
<tr valign="top" class="odd" id="version-prop">
<td class="tblQmlPropNode"><p>
<span class="name">version</span> : <span class="type">string</span></p></td></tr>
</table></div></div>
<div class="qmldoc"><p>The module's version. It consists of integer values separated by dots. You can check for specific values of this property in a <a href="qml-qbslanguageitems-depends.html">Depends</a> item.</p>
</div></div><!-- @@@version -->
<br/>
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="qml-qbslanguageitems-joblimit.html">JobLimit</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="qml-qbslanguageitems-moduleprovider.html">ModuleProvider</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
